<?php


define('INDEX_DOMAIN', 'index-domaine-redacteur.developpez.com');
define('MIME_CONTENT_TYPE_TEXTE', 'text/plain');
define('MIME_CONTENT_TYPE_JSON', 'application/json');
define('MIME_CONTENT_TYPE_HTML', 'text/html');
define('DEFAULT_TIMEOUT', 10);

define('HTTP_CODE_RESPONSE_SUCCESS', 200);
define('HTTP_CODE_INVALID_PARAMETER', 401);
define('HTTP_CODE_NOT_FOUND', 404);
define('HTTP_CODE_NOT_ALLOWED', 405);
define('HTTP_CODE_CONFLICT', 409);
define('HTTP_CODE_SERVER_ERROR', 500);
define('HTTP_CODE_TEMPORARILY_UNAVAILABLE', 503);

// erreur 400
class InvalidParameterException extends Exception {}

// erreur 404
class NotFoundException extends Exception {}

// erreur 405
class NotAllowedException extends Exception {}

// erreur 409
class ConflictException extends Exception {}

// erreur 500
class ServerErrorException extends Exception {}

// erreur 503
class TemporarilyUnavailableException extends Exception {}

class RestReturnData {
    public $code = false;
    public $mime_type = false;
    public $body = false;
}

class RestClass {
    public function get($url) {
		$result = @file_get_contents($url);
		if ($result === false) {
			return (object) array('code' => 404, 'body' => '');
        } else {
            return (object) array('code' => 200, 'body' => $result);
        }
    }

    public function HTTPError($code, $message=false) {
        ob_clean();
        header('HTTP/1.1 ' . $code, true, $code);
        header('Content-Type: ' . MIME_CONTENT_TYPE_HTML);
        ?>
        <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
        <html xmlns="http://www.w3.org/1999/xhtml" xml:lang="fr" lang="fr">
            <head>
                <meta http-equiv="Content-type" content="text/html; charset=UTF-8" />
                <meta http-equiv="Content-Language" content="fr" />
                <title>ineumann services erreur <?php echo $code; ?>
                </title>
            </head>
            <body>
                <h1>
                    DVP service error <?php echo $code; ?>
                </h1>
                <?php
                    if ($message){
                        echo "<p>" . $message . "</p>";
                    }
                ?>
            </body>
        </html>
        <?php
        exit(1);
    }

    public function getParameter($name){
        return (isset($_GET[$name])) ? $_GET[$name] : false;
    }

    public function urlServiceRubriques(array $param = array()){
    	$url = "https://" . INDEX_DOMAIN . "/rest/rubriques/";

    	if (isset($param['nameRubrique']) && $param['nameRubrique']){
    		$url .= 'nameRubrique/';
    	}

    	if (isset($param['idRubrique']) && $param['idRubrique']){
    		$url .= 'idRubrique/';
    	}

    	if (isset($param['name']) && $param['name']){
    		$url .= urlencode($param['name']);
    	}

    	if (isset($param['id']) && $param['id']){
    		$url .= urlencode($param['id']);
    	}

    	return $url;
    }

    public function urlServiceLicences(array $param = array()){
    	$url = "https://" . INDEX_DOMAIN . "/rest/licences/";

    	if (isset($param['nameLicence']) && $param['nameLicence']){
    		$url .= 'nameLicence/';
    	}

    	if (isset($param['idLicence']) && $param['idLicence']){
    		$url .= 'idLicence/';
    	}

    	if (isset($param['name']) && $param['name']){
    		$url .= urlencode($param['name']);
    	}

    	if (isset($param['id']) && $param['id']){
    		$url .= urlencode($param['id']);
    	}

    	return $url;
    }
}
