<?php
/*******************************************************************************
 * Auteur  : Developpez.com (ok.Idriss, Djibril)
 * But     : Création de la page d'index de domaine
 * Version : See VERSION constants value in includes/lib_all.php
 * *****************************************************************************/   

require_once ('includes/lib_all.php');

$rubrique               = XMLDocumentDVP::getSection();
$meta_description       = XMLDocumentDVP::getMetaValue('description');
$meta_keywords          = XMLDocumentDVP::getMetaValue('keywords');
$titre_page             = XMLDocumentDVP::getHeadTagValue('title');
$menu_status            = XMLDocumentDVP::getHeadTagValue('menu');
$Licence                = XMLDocumentDVP::getLicense();
$Annee                  = XMLDocumentDVP::getDateValue('license');
$dateBrute['date']      = XMLDocumentDVP::getDateValue('creation');
$dateBrute['miseajour'] = XMLDocumentDVP::getDateValue('update');
$urlCss                 = XMLDocumentDVP::getUrlCss();

$theme                  = XMLDocumentDVP::getTheme();
$GoogleAnalytics        = XMLDocumentDVP::getHeadTagValue('GoogleAnalytics');
$gabarit_encodage       = ENCODING_DEFAULT;
$gabarit_js             = "includes/functions.js";

// Récupération de la version xHTML du doctype
$gabarit_doctype = XMLDocumentDVP::getXHTMLVersion();
if (!$gabarit_doctype){
    $gabarit_doctype = VAR_XHMTL1; // xHTML 1.0 par défaut
}

// Favicon
if ($fav = XMLDocumentDVP::getFavicon()){
    $gabarit_favicon = $fav;
}

include $_SERVER['DOCUMENT_ROOT'] . "/template/entete.php";

echo  ENDLINE . "<!-- Version templateDVP : " . VERSION . " -->" . ENDLINE;

// Css optionnels
$path_optional_css = 'optionalCss';
if (file_exists($path_optional_css) && $handle = opendir($path_optional_css)){
    while (false !== ($entry = readdir($handle))) {
        if (preg_match("/\.css$/", $entry)){
            if ($gabarit_doctype == VAR_HTML5){
                echo "<style type='text/css' scoped>" . ENDLINE;
            } else {
                echo "<style type='text/css'>" . ENDLINE;
            }
            
            echo file_get_contents('optionalCss/' . $entry) . ENDLINE;
            echo "</style>" . ENDLINE;
        }
    }
}

function isNotIEOld(){
    return !preg_match("/MSIE [1-7]{1}/", $_SERVER["HTTP_USER_AGENT"]);
}

function affBadge($iduser, $version){
    return utf8_encode(@file_get_contents("https://www.developpez.com/ws/badge?user=" . $iduser . "&v=" . $version));
}

function isValidDeadline($date){
    if ($date && preg_match("/^[0-9]{2}\/[0-9]{2}\/[0-9]{4}$/", $date)){
        try {
            $tdate = explode("/", $date);
            $date = new DateTime($tdate[2] . "-" . $tdate[1] . "-" . $tdate[0] . " 00:00:00");
            $actual = new DateTime(); 
            $diff = (array) $actual->diff($date);

            return $diff['y'] < 1 && $diff['m'] < 1;
        } catch (Exception $e){
            return false;
        }
    }
    
    return false;
}

?>
<div id="xo_global">
    <div id="xo_alignement">

        <!-- Logo -->
        <?php
            $iduser = XMLDocumentDVP::getHeadTagValue('iduser');
            
            $arrayLogoBadge = XMLDocumentDVP::getLogoBadge();
            $logo = (isset($arrayLogoBadge['logo']) && $arrayLogoBadge['logo']) ? $arrayLogoBadge['logo'] : false;
            $badge = (isset($arrayLogoBadge['vbadge']) && $arrayLogoBadge['vbadge']) ? $arrayLogoBadge['vbadge'] : false;
            $align = (isset($arrayLogoBadge['align']) && $arrayLogoBadge['align']) ? $arrayLogoBadge['align'] : ALIGN_LEFT;
            
            if ($logo || $badge) { 
                echo "<div>" . ENDLINE;
                if ($logo) {
                    $logo = (preg_match("/^https?:/", $logo)) ? $logo : 'images/' . $logo;
                    if ($align != ALIGN_CENTER){
                        echo "<div style='float:" . $align . ";'><img src='" . $logo . "' alt='logo' /></div>" . ENDLINE;    
                    } else {
                        echo "<div style='text-align: center;'><img src='" . $logo . "' alt='logo' /></div>" . ENDLINE;
                    }
                }
                if ($badge) {
                    echo "<div style='float:right'>" . ENDLINE; 
                    echo affBadge($iduser, $badge) . ENDLINE;    
                    echo "</div>" . ENDLINE;        
                }
                echo "</div>" . ENDLINE . "<div style='clear:both;'>&nbsp;</div>" . ENDLINE;
            }
            
            $heading = XMLDocumentDVP::getHeadTagValue('heading');
            
            if ($heading){
                echo "<h1>" . $heading . "</h1>" . ENDLINE;
            }

            $hide_menu="";
            if($menu_status == "disable") {
               $hide_menu="style='display: none;'";
            }
        ?>
        
        <!-- Menu -->
        <div id="xo_menu" <?php echo $theme . " " . $hide_menu; ?>>
            <ul id="menuitems">
                <?php
                $xml = new XMLDocumentDVP(XMLDocumentDVP::getXmlFile());
                $xpathSections = $xml->xpath(XPATH_SECTION);
                if ($xpathSections) {
                    $i=0;
                    foreach ($xpathSections as $xmlSection) {
                        $onclick = "";
                        if (XMLDocumentDVP::getXpathValue(XPATH_CONTENT . '/@pagination', $xml) == NOMENCLATURE_OK && isNotIEOld()){
                            $onclick = " onclick=\"updateContent($i, " . sizeof($xpathSections) . "); return false;\"";
                        }
                        $link = XMLDocumentDVP::getXpathValue('@link', $xmlSection);
                        $title = XMLDocumentDVP::getXpathValue('@title', $xmlSection);
                        
                        echo "<li><a $theme id='xo_link_$i' href='&#35;" . $link . "'" . $onclick . ">&nbsp;" . $title . "&nbsp;</a></li>" . ENDLINE;
                        $i++;
                    }
                }
                ?>
            </ul>
        </div>

        <?php
        if ($xpathSections) {
            $i = 0;
            foreach ($xpathSections as $xmlSection) {
                $pagination = ($i != 0 && isNotIEOld() && XMLDocumentDVP::getXpathValue(XPATH_CONTENT . '/@pagination', $xml) == NOMENCLATURE_OK) ? "none;'" : "inline;'";
                echo "<div id='xo_section_$i' style='display: " . $pagination . ">";
                $i++;
                $link = XMLDocumentDVP::getXpathValue('@link', $xmlSection);
                $title = XMLDocumentDVP::getXpathValue('@title', $xmlSection);
                
                echo "<h2 $theme><a id='" . $link . "'></a>" . $title . "</h2>" . ENDLINE;

                // *** Les différents types de paragraphes
                $xpathParagraph = $xmlSection->xpath('paragraph'); 
                if ($xpathParagraph){
                    echo "<div class='xo_contenu'>" . ENDLINE;
                    foreach ($xpathParagraph as $xmlParagraph){
                        $type = XMLDocumentDVP::getXpathValue('@type', $xmlParagraph);

                        if ($type == "cdata"){
                            echo "<div class='cdata'>" . XMLDocumentDVP::toString($xmlParagraph) . "</div>" . ENDLINE . "<br />" . ENDLINE;
                        } else if ($type == "cv"){
                            echo "<div class='cv'>" . ENDLINE;
                            
                            // *** Premier item
                            $itemCvFirst = XMLDocumentDVP::getXpathValue(XPATH_ITEM_CV_FIRST, $xmlParagraph);
                            
                            if ($itemCvFirst) {
                                echo $itemCvFirst . "<br /><br />" . ENDLINE;
                            }
                            
                            // *** Autres items
                            $xpathItemsCv = $xmlParagraph->xpath(XPATH_ITEM_CV);
                            if ($xpathItemsCv) {
                                echo "<ul>" . ENDLINE;
                                foreach ($xpathItemsCv as $xmlItem) {
                                    $title = XMLDocumentDVP::getXpathValue('@title', $xmlItem);
                                    echo "<li><b>" . $title . " :</b> " . XMLDocumentDVP::toString($xmlItem) . "</li>" . ENDLINE;
                                }
                                echo "</ul>" . ENDLINE;
                            }
                            
                            echo "</div>" . ENDLINE;
                        } else if ($type == "mp" && XMLDocumentDVP::getHeadTagValue('iduser')){
                            echo "<div class='cdata'>" . ENDLINE
                                . "Vous pouvez me contacter par <a href='https://www.developpez.net/forums/private.php?do=newpm&amp;u=" . XMLDocumentDVP::getHeadTagValue('iduser') . "' " . JS_BLANK . ">message priv&eacute;</a> via le forum de developpez.com." . ENDLINE
                                . "</div>" . ENDLINE;
                        } else if ($type == "twitter-widget"){ 
                            $class = XMLDocumentDVP::getXpathValue('@class', $xmlParagraph);
                            $idWidget = XMLDocumentDVP::getXpathValue('@id', $xmlParagraph);
                            $pseudo = XMLDocumentDVP::getXpathValue('@pseudo', $xmlParagraph);
                            
                            if ($class && $idWidget && $pseudo){
                                $titleWidge = XMLDocumentDVP::getXpathValue('@title', $xmlParagraph);
                                
                                echo "<div style='padding-top: 10px;'>" . ENDLINE;
                                
                                if($titleWidge){
                                    echo "<div class='cdata'>" . $titleWidge . "</div><br />" . ENDLINE;
                                }
                                
                                echo "<a class='" . $class . "' href='https://twitter.com/" . $pseudo
                                        . "' data-widget-id='" . $idWidget . "'>Tweets de @" . $pseudo . "</a>" . ENDLINE;
                                
                                echo "<script type='text/javascript'>" . ENDLINE 
                                        . "!function(d, s,id){" . ENDLINE 
                                        . "var js, fjs = d.getElementsByTagName(s)[0];" . ENDLINE 
                                        . "if(!d.getElementById(id)){" . ENDLINE 
                                        . "js=d.createElement(s);" . ENDLINE 
                                        . "js.id=id;" . ENDLINE 
                                        . "js.src='//platform.twitter.com/widgets.js'" . ENDLINE 
                                        . "fjs.parentNode.insertBefore(js,fjs);" . ENDLINE 
                                        . "}" . ENDLINE . "}(document, 'script','twitter-wjs');" . ENDLINE 
                                        . "</script>" . ENDLINE;
                                
                                echo "</div>" . ENDLINE;
                            }
                        } else {
                            echo "<p>" . XMLDocumentDVP::toString($xmlParagraph) . "</p>" . ENDLINE;
                        }
                    }
                    
                    echo "</div>" . ENDLINE;
                }

                // *** Partie sous sections
                $xpathSections2 = $xmlSection->xpath('section2');
                if ($xpathSections2) {
                    echo "<div class='xo_contenu'>" . ENDLINE;
                    foreach ($xpathSections2 as $xmlSection2) {
                        $title = XMLDocumentDVP::getXpathValue('@title', $xmlSection2);
                        if ($title){
                            $styleh2 = "";
                            $nomaj = XMLDocumentDVP::getXpathValue(XPATH_CONTENT . '/@nomaj', $xml);
                            if ($nomaj == NOMENCLATURE_OK){
                                $styleh2 = " style='text-transform: none'";
                            }
                            echo "<h3" . $styleh2 . ">" . $title . "</h3>";
                        }
                        
                        $xpathItems = $xmlSection2->xpath('item');
                        if ($xpathItems) {
                            echo "<ul>" . ENDLINE;
                            foreach ($xpathItems as $xmlItem) {
                                $link = XMLDocumentDVP::getXpathValue('@link', $xmlItem);
                                $is_title = XMLDocumentDVP::getXpathValue('@is_title', $xmlItem);

                                $annotation = ""; 
                                $title = "";
                                
                                $new = XMLDocumentDVP::getXpathValue('@new', $xmlItem);
                                
                                if($new){
                                    $title .= "cr&eacute;e le " . $new;
                                }
                                
                                if (isValidDeadline($new)){
                                    $annotation .= " <span style='color: red; font-size: x-small;'>(nouveau : " . $new . ")</span>";
                                }
                                
                                $update = XMLDocumentDVP::getXpathValue('@update', $xmlItem);
                                
                                if ($update){
                                    if ($new){
                                        $title .= ", ";
                                    }
                                    $title .= "mis &agrave; jour le " . $update;
                                }
                                
                                if ($title){
                                    $title = " title='" . $title . "'";
                                }
                                
                                if(isValidDeadline($update)){
                                    $annotation .= " <span style='color: green; font-size: x-small;'>(mis &agrave; jour le " . $update . ")</span>";
                                }
                                
                                if ($is_title == "true") {
                                    echo "<li class='section_subtitle'>" . XMLDocumentDVP::toString($xmlItem) . "</li>";
                                } else if ($link) {
                                    echo "<li" . $title . "><a href='" . $link . "' " . JS_BLANK . ">" . XMLDocumentDVP::toString($xmlItem) . $annotation . "</a></li>" . ENDLINE;
                                } else {
                                    echo "<li" . $title . " class='inactif'>" . XMLDocumentDVP::toString($xmlItem) . $annotation . "</li>" . ENDLINE;
                                }
                            }
                            echo "</ul>" . ENDLINE;
                        }
                    }
                    echo "</div>" . ENDLINE;
                }
                echo "</div>" . ENDLINE;
            }
        }
        
        $vXhtml = XMLDocumentDVP::getXHTMLVersion(true);
        $vCss = XMLDocumentDVP::getHeadTagValue('css');

        if ($vXhtml && $vCss) {
            echo "<p id='infos_page'>Cette page est valide <a href='http://validator.w3.org/check?uri=referer' "
            . JS_BLANK . ">" . $vXhtml
            . "</a> et <a href='http://jigsaw.w3.org/css-validator/check/referer' "
            . JS_BLANK . ">" . $vCss
            . "</a></p>" . ENDLINE;
        } else if ($vXhtml) {
            echo "<p id='infos_page'>Cette page est valide <a href='http://validator.w3.org/check?uri=referer' "
            . JS_BLANK . ">" . $vXhtml . "</a></p>" . ENDLINE;
        } else if ($vCss) {
            echo "<p id='infos_page'>Cette page est valide <a href='http://jigsaw.w3.org/css-validator/check/referer' "
            . JS_BLANK . ">" . $vCss . "</a></p>" . ENDLINE;
        }
        ?>
    </div>
</div>

<?php include ($_SERVER['DOCUMENT_ROOT'] . "/template/pied.php"); ?>
