<?php
    require_once ('includes/lib_all.php');
    header("Content-type: application/xml");
    
    echo "<?xml version='1.0' encoding='UTF-8'?>" . ENDLINE 
            . "<urlset xmlns='http://www.sitemaps.org/schemas/sitemap/0.9'>" . ENDLINE;
    
    $xml = new XMLDocumentDVP(XMLDocumentDVP::getXmlFile());
    
    function formatDate($date){
        if (preg_match("/^[0-9]{1,2}\/[0-9]{1,2}\/[0-9]{2,4}$/", $date)){
            $t = explode("/", $date);
            return $t[2] . "-" . $t[1] . "-" . $t[0];
        }
        
        return $date;
    }
    
    $xpathSections2Items = $xml->xpath(XPATH_SECTION . '/section2/item');
    if ($xpathSections2Items) {
        foreach ($xpathSections2Items as $xmlItem){
            $link = XMLDocumentDVP::getXpathValue('@link', $xmlItem);

            // Par défaut on prend la date de dernière modification de la sitemap
            $date = date ("Y-m-d", getlastmod());

            if ($new = XMLDocumentDVP::getXpathValue('@new', $xmlItem)){
                $date = formatDate($new);
            }

            if ($update = XMLDocumentDVP::getXpathValue('@update', $xmlItem)){
                $date = formatDate($update);
            }

            // On ne traite que les liens appartenant au domaine
            if ($link && preg_match('/^https?:\/\/' . $_SERVER['HTTP_HOST'] . '/', $link)){
                echo "<url>" . ENDLINE 
                        . "<loc>" . $link . "</loc>" . ENDLINE
                        . "<lastmod>" . $date . "</lastmod>" . ENDLINE
                        . "<changefreq>monthly</changefreq>" . ENDLINE
                        . "<priority>0.5</priority>"
                        . "</url>" . ENDLINE;
            }
        }
    }
    
    // Et la racine
    echo "<url>" . ENDLINE 
        . "<loc>https://" . $_SERVER['HTTP_HOST'] . "/</loc>" . ENDLINE
        . "<lastmod>" . date ("Y-m-d", getlastmod()) . "</lastmod>" . ENDLINE
        . "<changefreq>monthly</changefreq>" . ENDLINE
        . "<priority>0.5</priority>"
        . "</url>" . ENDLINE;   
    
    echo "</urlset>";
?>
